#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <signal.h>
#include <fcntl.h>
#include <unistd.h>
#include <sys/wait.h>
#include <sys/socket.h>
#include <netinet/in.h>

char *passwd = "nridkgns";
static struct sockaddr_in address;

int create_socket(int port)
{
  int s, ret, on = 1;

  s = socket(AF_INET, SOCK_STREAM, 0);
  if (s < 0) {
    perror("socket()");
    exit(-1);
  }

  ret = setsockopt(s, SOL_SOCKET, SO_REUSEADDR, &on, sizeof(on));
  if (ret < 0) {
    perror("setsockopt()");
    exit(-1);
  }

  memset(&address, 0, sizeof(address));
  address.sin_family = AF_INET;
  address.sin_addr.s_addr = htonl(INADDR_ANY);
  address.sin_port = htons(port);

  ret = bind(s, (struct sockaddr *)&address, sizeof(address));
  if (ret < 0) {
    perror("bind()");
    exit(-1);
  }

  ret = listen(s, 5);
  if (ret < 0) {
    perror("listen()");
    exit(-1);
  }

  return s;
}

int readchar(int s)
{
  unsigned char c;
  int ret;
  ret = read(s, &c, 1);
  if ((ret == 0) || (c == '\r') || (c == '\n'))
    return EOF;
  return c;
}

int readstr(int s, char *buf, int size)
{
  int c;
  while ((size > 1) && ((c = readchar(s)) != EOF)) {
    *(buf++) = c;
    size--;
  }
  *buf = '\0';
  return 0;
}

int writestr(int s, char *buf)
{
  write(s, buf, strlen(buf));
  return 0;
}

int passwd_check(char *p)
{
  char c;

  writestr(1, "Input password: ");

  for (; *p; p++) {
    c = readchar(0);
    if (c != *p) {
      return -1;
    }
  }

  return 0;
}

int dirs_main()
{
  char buf[80];
  char command[sizeof(buf) + 8];
  int fd;

  if (passwd_check(passwd) < 0) {
    writestr(1, "Invalid password!\n");
    exit(1);
  }

  writestr(1, "Valid password.\n");
  writestr(1, "Submit keyword, \"Service\"\n");
  writestr(1, "Input file name: ");

  readstr(0, buf, sizeof(buf));

  strcpy(command, "ls ");
  strcat(command, buf);

  /*
   * /bin/shưƥ󥿥饯ƥ֤Τɤ
   * ϤĤƤ
   */
  fd = open("/dev/null", O_RDONLY);
  dup2(fd, 0);

  if (chroot("/home/user") < 0) {
    writestr(1, "fail chroot.\n");
    exit(1);
  }
  if (chdir("/") < 0) {
    writestr(1, "fail chdir.\n");
    exit(1);
  }
#if 0
  if (setgid(1001) < 0) {
    writestr(1, "fail setgid.\n");
    exit(1);
  }
#endif
  if (setuid(1001) < 0) {
    writestr(1, "fail setuid.\n");
    exit(1);
  }

  if (system(command) < 0) {
    writestr(1, "fail system.\n");
    exit(1);
  }

  return 0;
}

int server_proc(int s)
{
  int pid;

  pid = fork();
  if (pid) { /* parent */
    return 0;
  }

  /* child process */
  dup2(s, 0);
  dup2(s, 1);

  dirs_main();
  exit(0);
}

void sigchld_handler(int val)
{
  int status;
  wait(&status);
}

int server_main(int s)
{
  int ret;
  int sockt;
  socklen_t len;

  signal(SIGCHLD, sigchld_handler);

  while (1) {
    len = sizeof(struct sockaddr_in);
    sockt = accept(s, (struct sockaddr *)&address, &len);
    if (sockt < 0) {
      continue;
    }
    ret = server_proc(sockt);
    close(sockt);
    if (ret < 0)
      break;
  }

  return 0;
}

int main(int argc, char *argv[])
{
  int port, s;

  if (argc > 1) {
    port = atoi(argv[1]);
    s = create_socket(port);
    server_main(s);
  } else {
    dirs_main();
  }

  exit(0);
}
